/*
 * Jakelib2 - General purpose C++ library
 * Copyright (C) 2001 Florian Wolff  (florian@donuz.de)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: jlpplib.h,v 1.3 2002-09-21 10:28:30 florian Exp $
 */


/**
 * Borland C++
 */
#ifdef __BORLANDC__
# undef WIN32
# define WIN32
# define BORLAND
#endif

/**
 * Microsoft Visual C++
 */
#ifdef _MSC_VER
# undef WIN32
# define WIN32
# define MSVC
#endif

/**
 * Include some standard include files
 */
#include <stdio.h>
#include <stdlib.h>


/**
 * Linux/Unix Environment
 */
#ifdef UNIX
# include <iostream.h>
# include <semaphore.h>

  inline int min(int a, int b) { return ( a < b ? a : b); }
  inline int max(int a, int b) { return ( a > b ? a : b); }
  inline long min(long a, long b) { return ( a < b ? a : b); }
  inline long max(long a, long b) { return ( a > b ? a : b); }
#endif


/**
 * Windows32 Environment
 */
#ifdef WIN32
   #include <windows.h>
#endif


#ifndef TRUE
# define TRUE 1
# define FALSE 0
#endif

#if !defined(boolean) && !defined(MSVC)
   typedef bool boolean;
#endif


#define ZREF(o) if ((o) != NULL) (o)->ref();
#define ZUNREF(o) if ((o) != NULL && (o)->unref() == 0) delete (o);


#include "ZObject.h"
#include "ZString.h"
#include "ZException.h"
#include "ZArrayList.h"

