/* Generated automatically by jlpp - do not edit. */

#line 1 "io/PipeOutputStream.jlc"
// -*- c++ -*-

/*
 * Jakelib2 - General purpose C++ library
 * Copyright (C) 2001 Florian Wolff  (florian@donuz.de)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: PipeOutputStream.jlc,v 1.8 2003-09-27 08:10:28 florian Exp $
 */


#include "jakelib2.h"
#include "jakelib2/io/PipeOutputStream.h"
#include "jakelib2/lang/System.h"
#include <string.h>

#ifdef HAVE_ERRNO_H
# include <errno.h>
#endif

using namespace jakelib::lang;
using namespace jakelib::io;

JAKELIB_IMPLEMENT_CLASS("jakelib.io.PipeOutputStream", PipeOutputStream, OutputStream)

#if !defined(JAKELIB_WIN32API)
# include <unistd.h>
#endif


/*****************************************************************************\
 * PipeOutputStream                                                           |
 *****************************************************************************/
#if defined(JAKELIB_WIN32API)

PipeOutputStream::PipeOutputStream(HANDLE pipe)
{
  this->pipe = pipe;
}

#else

PipeOutputStream::PipeOutputStream(int pipe)
{
  this->pipe = pipe;
}

#endif

PipeOutputStream::~PipeOutputStream()
{
  close();
}


/*****************************************************************************\
 * write                                                                      |
 *****************************************************************************/
void PipeOutputStream::write(int b)
{
  jbyte c = (jbyte) b;

#if !defined(JAKELIB_WIN32API)
  ::write(pipe, &c, 1);
#else
  throw new UnsupportedOperationException(new String("PipeOutputStream::write is not yet supported for Borland C++"));
#endif
}


/*****************************************************************************\
 * write                                                                      |
 *****************************************************************************/
void PipeOutputStream::write(jbyte* b, int offset, int len)
{
  if (b == null)
    throw new NullPointerException();
  else if (len < 0 || offset < 0)
    throw new IndexOutOfBoundsException();
  else if (len == 0)
    return;
  
#if defined(JAKELIB_WIN32API)

  DWORD w, totalWritten = 0;

  do {
    if (!WriteFile(pipe, &b[offset + totalWritten], len - totalWritten, &w, NULL)) {
      throw new IOException(System::explainErrorCode(GetLastError())
                        ->plus( JAKELIB_AT2("jakelib.io.PipeOutputStream.write")));
    }
    totalWritten += w;
  } while (totalWritten < (DWORD)len);

#else

  int totalWritten = 0;

  do {
    int w = ::write(pipe, &b[offset + totalWritten], len - totalWritten);

    if (w < 0) {
      throw new IOException(System::explainErrorCode(errno)
                        ->plus( JAKELIB_AT2("jakelib::io::PipeOutputStream.write")));
    }
    totalWritten += w;
  } while (totalWritten < len);

#endif
}


/*****************************************************************************\
 * close                                                                      |
 *****************************************************************************/
void PipeOutputStream::close()
{
#if defined(JAKELIB_WIN32API)
  CloseHandle(pipe);
#else
  ::close(pipe);
#endif
}


