/* Generated automatically by jlpp - do not edit. */

#include <jakelib2.h>
static jakelib::lang::String* jakelib2_strings[] = {null, null, null};

// "Skip value is negative"
static jchar chars_jakelib2_str_0[] = {83,107,105,112,32,118,97,108,117,101,32,105,115,32,110,101,103,97,116,105,118,101};
// "mark() not supported"
static jchar chars_jakelib2_str_1[] = {109,97,114,107,40,41,32,110,111,116,32,115,117,112,112,111,114,116,101,100};
// "reset() not supported"
static jchar chars_jakelib2_str_2[] = {114,101,115,101,116,40,41,32,110,111,116,32,115,117,112,112,111,114,116,101,100};
#line 1 "io/Reader.jlc"
// -*- c++ -*-

/*
 * Jakelib2 - General purpose C++ library
 * Copyright (C) 2001 Florian Wolff  (florian@donuz.de)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: Reader.jlc,v 1.5 2003-09-27 08:10:28 florian Exp $
 */


#include "jakelib2.h"
#include "jakelib2/io/Reader.h"
#include "jakelib2/lang/Synchronizer.h"
#include "jakelib2/lang/Synchronizeable.h"
#include "jakelib2/lang/Math.h"

using namespace jakelib::lang;
using namespace jakelib::io;

JAKELIB_IMPLEMENT_CLASS("jakelib.io.Reader", Reader, Object);

#ifndef WINOWS32
# include <stdlib.h>
# include <string.h>
#endif


const int Reader::maxSkipBufferSize = 8192;


/*****************************************************************************\
 * Reader                                                                     |
 *****************************************************************************/
Reader::Reader()
  : skipBuffer(null)
{
#ifdef JAKELIB_THREADS
  this->lock = new Synchronizer();
#endif
}

Reader::Reader(Synchronizeable* lock)
  : skipBuffer(null)
{
#ifdef JAKELIB_THREADS
  if (lock == null)
    throw new NullPointerException(JAKELIB_AT2("jakelib.io.Reader.Reader"));

  this->lock = lock;
#endif
}


/*****************************************************************************\
 * ~Reader                                                                    |
 *****************************************************************************/
Reader::~Reader()
{
  free(skipBuffer);
}


/*****************************************************************************\
 * read                                                                       |
 *****************************************************************************/
int Reader::read()
{
  jchar b;
  if (read(&b, 0, 1) == -1)
    return -1;
  else
    return (int) b;
}


/*****************************************************************************\
 * skip                                                                       |
 *****************************************************************************/
int Reader::skip(int n)
{
  if (n < 0)
    throw new IllegalArgumentException(JAKELIB_ONDEMAND(jakelib2_strings[0], new jakelib::lang::String(chars_jakelib2_str_0, 0, 22))
       ->plus( JAKELIB_AT2("jakelib.io.Reader.skip")));

  if (skipBuffer == null)
    skipBuffer = (jchar*) malloc(sizeof(jchar) * maxSkipBufferSize);

  JAKELIB_SYNCHRONIZED(lock);

  int toRead = n;
  int r;

  while (toRead > 0) {
    r = read(skipBuffer, 0, Math::min(toRead, maxSkipBufferSize));
    if (r < 0)
      break;
    toRead -= r;
  }

  return n - toRead;;
}


/*****************************************************************************\
 * ready                                                                      |
 *****************************************************************************/
jboolean Reader::ready()
{
  return false;
}


/*****************************************************************************\
 * markSupported                                                              |
 *****************************************************************************/
jboolean Reader::markSupported()
{
  return false;
}


/*****************************************************************************\
 * mark                                                                       |
 *****************************************************************************/
void Reader::mark(int readLimit)
{
  throw new IOException(JAKELIB_ONDEMAND(jakelib2_strings[1], new jakelib::lang::String(chars_jakelib2_str_1, 0, 20))
      ->plus( JAKELIB_AT2("jakelib.io.Reader.mark")));
}


/*****************************************************************************\
 * reset                                                                      |
 *****************************************************************************/
void Reader::reset()
{
  throw new IOException(JAKELIB_ONDEMAND(jakelib2_strings[2], new jakelib::lang::String(chars_jakelib2_str_2, 0, 21))
      ->plus( JAKELIB_AT2("jakelib.io.Reader.reset")));
}

