/* Generated automatically by jlpp - do not edit. */

#line 1 "lang/Semaphore.jlc"
/*
 * Jakelib2 - General purpose C++ library
 * Copyright (C) 2001 Florian Wolff  (florian@donuz.de)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: Semaphore.jlc,v 1.3 2003-09-27 08:10:28 florian Exp $
 */


#include "jakelib2.h"
#include "jakelib2/lang/Semaphore.h"

using namespace jakelib::lang;

JAKELIB_IMPLEMENT_CLASS("jakelib.lang.Semaphore", Semaphore, Object)

#if !defined(JAKELIB_WIN32API)
# define INFINITE 0
#endif


/*****************************************************************************\
 * Semaphore                                                                  |
 *****************************************************************************/
Semaphore::Semaphore()
{
  init(1);
}


Semaphore::Semaphore(int startCount)
{
  init(startCount);
}

Semaphore::~Semaphore()
{
#if defined(JAKELIB_WIN32API)
  CloseHandle(handle);
#else
  sem_destroy(&sema);
#endif
}


/*****************************************************************************\
 * init                                                                       |
 *****************************************************************************/
void Semaphore::init(int start)
{
#if defined(JAKELIB_WIN32API)
  handle = CreateSemaphore(null, start, 0x7fffffff, null);
  if (handle == null)
    throw new Exception(String("Semaphore(").plus(start)
      ->plus("): Cannot create semaphore (") 
      ->plus((jlong) GetLastError())->plus(")."));
#else
  sem_init(&sema, 0, start);
#endif
}


/*****************************************************************************\
 * wait                                                                       |
 *****************************************************************************/
void Semaphore::wait(long millis)
{
#if defined(JAKELIB_WIN32API)
  WaitForSingleObject(handle, millis);
#else
  if (millis != INFINITE)
    throw new UnsupportedOperationException(new String("Semaphore.wait(long) not yet implemented."));
  
  sem_wait(&sema);
#endif
}

void Semaphore::wait()
{
  wait(INFINITE);
}


/*****************************************************************************\
 * notify                                                                     |
 *****************************************************************************/
void Semaphore::notify()
{
  long  l;

#if defined(JAKELIB_WIN32API)
  ReleaseSemaphore(handle, 1, &l);
#else
  sem_post(&sema);
#endif
}


/*****************************************************************************\
 * p                                                                          |
 *****************************************************************************/
void Semaphore::p()
{
  wait();
}


/*****************************************************************************\
 * v                                                                          |
 *****************************************************************************/
void Semaphore::v()
{
  notify();
}
