/* Generated automatically by jlpp - do not edit. */

#line 1 "text/enc/ByteToCharUTF8.jlc"
/*
 * Jakelib2 - General purpose C++ library
 * Copyright (C) 2001 Florian Wolff  (florian@donuz.de)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: ByteToCharUTF8.jlc,v 1.2 2003-09-27 08:10:28 florian Exp $
 */


#include "jakelib2.h"
#include "jakelib2/text/enc/ByteToCharUTF8.h"
#include "jakelib2/io/InputStream.h"

using namespace jakelib::lang;
using namespace jakelib::util;
using namespace jakelib::text::enc;

JAKELIB_IMPLEMENT_CLASS("jakelib.text.enc.ByteToCharUTF8", ByteToCharUTF8, ByteToCharConverter)


/*****************************************************************************\
 * ByteToCharUTF8                                                            |
 *****************************************************************************/
ByteToCharUTF8::ByteToCharUTF8()
  : ByteToCharConverter("UTF8")
{}


/*****************************************************************************\
 * convert                                                                    |
 *****************************************************************************/
int ByteToCharUTF8::convert(jakelib::io::InputStream* inputStream,
        jchar* output, int len)
{
  int b1, b2, b3, b4;
  int charsWritten;

  for (charsWritten = 0; charsWritten < len; charsWritten++) {
    b1 = inputStream->read();

    // End of input stream?
    if (b1 < 0)
      break;

    if (b1 <= 0x7f) {
      // Just one byte:
      output[charsWritten] = b1 & 0x7f;
    }
    else if (b1 <= 0xe0) {
      // Two bytes:
      
      b2 = inputStream->read();
      if (b2 < 0)
 break;
      output[charsWritten] = ((b1 & 0x3f) << 6) | (b2 & 0x7f);
    }
    else if (b1 <= 0xf0) {
      // Three bytes:
      
      b2 = inputStream->read();
      if (b2 < 0)
 break;
      b3 = inputStream->read();
      if (b3 < 0)
 break;

      output[charsWritten] = ((b1 & 0x1f) << 12) | ((b2 & 0x7f) << 6) | (b3 & 0x3f);
    }
    else {
      // Four bytes:
      
      b2 = inputStream->read();
      if (b2 < 0)
 break;
      b3 = inputStream->read();
      if (b3 < 0)
 break;
      b4 = inputStream->read();
      if (b4 < 0)
 break;
    }
  }

  return charsWritten;
}

