/* Generated automatically by jlpp - do not edit. */

#line 1 "text/enc/CharToByteUTF8.jlc"
/*
 * Jakelib2 - General purpose C++ library
 * Copyright (C) 2001 Florian Wolff  (florian@donuz.de)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: CharToByteUTF8.jlc,v 1.2 2003-09-27 08:10:28 florian Exp $
 */


#include "jakelib2.h"

#include "jakelib2/text/enc/CharToByteUTF8.h"
#include "jakelib2/util/ByteArray.h"

using namespace jakelib::lang;
using namespace jakelib::util;
using namespace jakelib::text::enc;

JAKELIB_IMPLEMENT_CLASS("jakelib.text.enc.CharToByteUTF8", CharToByteUTF8, CharToByteConverter);


/*****************************************************************************\
 * CharToByteUTF8                                                             |
 *****************************************************************************/
CharToByteUTF8::CharToByteUTF8()
  : CharToByteConverter("UTF8")
{}


/*****************************************************************************\
 * convert                                                                    |
 *****************************************************************************/
void CharToByteUTF8::convert(jchar* input, int inOff, int inEnd,
        ByteArray* output)
{
  jchar c;

  for (; inOff < inEnd; inOff++) {
    c = input[inOff];

    if (c < 0x80) {
      output->add(c & 0xff);
    }
    else if (c < 0x800) {
      output->add(0xc0 | (c >> 6));
      output->add(0x80 | (c & 0x3f));
    }
    else if (c < 0x1000) {
      output->add(0xe0 | (c >> 12));
      output->add(0x80 | ((c >> 6) & 0x3f));
      output->add(0x80 | (c & 0x3f));
    }
    // Will never happen as long as we have 16 bits per character only!
    else if (c < 0x20000) {
      output->add(0xf0 | (c >> 18));
      output->add(0x80 | ((c >> 12) & 0x3f));
      output->add(0x80 | ((c >> 6) & 0x3f));
      output->add(0x80 | (c & 0x3f));
    }
  }
}

